/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * sample of lambda
 */
 

define plus_a = (lambda x,y,z: x + (y + z)).

define plus_b = (lambda x: (lambda y,z: x + (y + z))).

define plus_c = (lambda x: (lambda y: (lambda z: x + (y + z)))).

define plus_d = (lambda y,z: (y + z)).

define plus_e = (lambda x: x + plus_d(2,3)).

define plus_f = (lambda x,y: x+x).

define plus_f_1(x, y) = {x+x}.

define plus_g = (lambda x: (lambda y: (lambda z: (lambda op: op(op(x,y),z))))).

define plus_g_1 = (lambda op: (lambda x: (lambda y: (lambda z: op(op(x,y),z))))).

define plus_g_2 = (lambda x: (lambda op: (lambda y: (lambda z: op(op(x,y),z))))).

define plus_g_u = (lambda x,y,z,op: op(op(x,y),z)).

define plus_g_u_1 = (lambda op,x,y,z: op(op(x,y),z)).

define plus_h = (lambda x: (lambda y: (lambda x: x+y))).

define plus_i = (% x: (% y: (% x: x+y))).


define while_f_e = (% E: (% c: (% s: if c(E) then { s(E); while_f_e(E)(c)(s) } else empty ))).


/********************************************************/

  
/* run */ define test_1() = {
 exists X: {
  X = plus_a(1,2,3) and output(X) and empty
 }
}.

/* run */ define test_2_a() = {
 exists X,Y: {
  X = plus_b(1) and Y = X(2,3) and output(X,Y) and empty
 }
}.

/* run */ define test_2_b() = {
 exists X,Y,V: {
  X = plus_b(1) and Y = X(2,3) and V = X(2,5) and
  output(X,Y,V) and empty
 }
}.

/* run */ define test_2_c() = {
 exists X : {
   X = plus_b(1)(4,5) and output( X, plus_b(2)(4,5) ) and empty
 }
}.

/* run */ define test_2_d() = {
 exists X: { 
  output( (% x : (% y : (% z: x*(y*z)) ))(1)(2)(3) ) and empty
 }
}.


/* run */ define test_3() = {
 exists X,Y,W: {
  X = plus_c(1) and Y = X(2) and W = Y(3) and
  output(X,Y,W) and empty
 }
}.


/* run */ define test_4_a() = {
 exists W: {
  W = plus_e(1) and output(W) and empty
 }
}.

/* run */ define test_4_b() = {
 exists X1,Y,W: {
  W = plus_h(1)(2)(3) and output(W) and empty
 }
}.

/* run */ define test_4_c() = {
 exists X1,Y,W: {
  W = plus_i(1)(2)(3) and output(W, (% x : x+1)(4) ) and empty
 }
}.

/* run */ define test_5() = {
  exists X: {
    output(plus_f(2,3)) and empty
  }
}.

/* run */ define test_6_0() = {
 exists W: {
  W = plus_g(2)(3)(4)(plus_d) and output(W) and empty
 }
}.

/* run */ define test_6_1() = {
 exists W: {
  W = plus_g_1(plus_d)(2)(3)(4) and
  output(W) and empty
 }
}.

/* run */ define test_6_2() = {
 exists W: {
  W = plus_g_2(2)(plus_d)(3)(4) and output(W) and empty
 }
}.


/* run */ define test_6_3() = {
 exists W: {
  W = plus_g_u(2,3,4,plus_d) and output(W) and empty
 }
}.

/* run */ define test_6_4() = {
 exists X1,Y,W: {
  W = plus_g_u_1(plus_d,2,3,4) and output(W) and empty
 }
}.


/* run */ define test_7() = {
 exists W: {
  W = plus_g(2)(3)(4)( (lambda x,y : x*y) ) and
  output(W) and empty
 }
}.

/* run */ define test_8() = {
 exists X1,Y,W: {
  W = plus_g(2)(3)(4)( (lambda x,y : x*y) ) and
  W := plus_g(2)(3)(4)( plus_d ) and
  always output(W) and skip
 }
}.

/* run */ define test_9() = {
 exists X,Y,W: {
  X = 0 and X gets X + 1 and
  Y = 0 and Y gets Y + 2 and
  W = 0 and W gets plus_g(X)(Y)(W)( plus_d ) and
  always output([W,X,Y]) and len 6
 }
}.

/* run */ define test_10_a() = {
 exists X,W: { X = 0 and always output X and
  while_f_e(X)( (% Y : Y<5) )( (% Z: Z:=Z+1 and skip ) ) 
 }
}.

/* run */ define test_10_b() = {
 exists X,W: {
  W = [0,1] and list(W,2) and stable(struct(W)) and
  always output W and
  while_f_e(W)( (% Y : Y[0]<5) )
            ( (% Z: Z[0]:=Z[0]+1 and Z[1]:=Z[1]+Z[0] and skip ) ) 
 }
}.

/* run */ define test_11() = {
 exists X,W: {
  X = 0 and W = 1 and always output (X,W) and
   while_f_e(X)( (% Y : Y<5 ) )( (% Z: Z:=Z+1 and skip ) ) and
  (while_f_e(W)( (% Y : Y<5 ) )( (% Z: Z:=Z+2 and skip ) );true) 
 }
}.



/* run */ define test_12() = {
 exists X,W: {
  X = 0 and W = 1 and always output (X,W) and
   while_f_e(X)( (% Y : Y<5 ) )( (% Z: Z:=Z+1 and skip ) ) and
   while_f_e(W)( (% Y : Y<10) )( (% Z: Z:=Z+2 and skip ) )
 }
}.

/* run */ define test_13() = {
 exists X : {
  define while_f = (% c : (% s : if c() then { s(); while_f(c)(s) } else empty )) and
  X = 0 and always output X and
  while_f( (%  : X<5) )( (%  : X:=X+1 and skip ) ) 
 }
}.

/* run */ define test_14_a() = {
 exists X,W: {
  load "external_func" and
  X = 0 and W=0 and always output (X,W) and
   while_f( (%  : X<5) )( (%  : X:=X+1 and skip ) ) and
  (while_f( (%  : W<6) )( (%  : W:=W+2 and skip ) );true)
 }
}.

/* run */ define test_14_a_0() = {
 exists X: {
  load "external_func" and
  X = 0  and always output (X) and
   while_f( (%  : X<5) )( (%  : X:=X+1 and skip ) ) and
  exists X : {
   X = 0  and always output (X) and
   while_f( (%  : X<5) )( (%  : X:=X+1 and skip ) )
   }
 }
}.

/* run */ define test_14_a_1() = {
 exists X: {
  define while_f = (% d, c, s : if c() then { (output d and s()); while_f(d,c,s) } else empty ) and
  X = 0  and always output (X) and
   while_f( 2, (%  : X<5) , (%  : X:=X+1 and skip ) ) and
  exists X : {
   X = 0  and always output (X) and
   while_f( 3, (%  : X<5) , (%  : X:=X+1 and skip ) )
   }
 }
}.

/* run */ define test_14_a_2() = {
 exists X: {
  define while_f = (%  c, s, d : if c() then { (output d and s()); while_f(c,s,d) } else empty ) and
  X = 0  and always output (X) and
   while_f(  (%  : X<5) , (%  : X:=X+1 and skip ), 2 ) and
  exists X : {
   X = 0  and always output (X) and
   while_f(  (%  : X<5) , (%  : X:=X+1 and skip ), 3 )
   }
 }
}.

/* run */ define test_14_a_3() = {
 exists X: {
  define while_f = (%  c : (% s : (% d : if c() then { (output d and s()); while_f(c)(s)(d) } else empty ))) and
  X = 0  and always output (X) and
   while_f(  (%  : X<5) )( (%  : X:=X+1 and skip ) )( 2 ) and
  exists Y : {
   Y = 0  and always output (Y) and
   while_f(  (%  : Y<5) )( (%  : Y:=Y+1 and skip ) )( 3 )
   }
 }
}.

/* run */ define test_14_a_4() = {
 exists X: {
  define while_f = (   (% d,c : (% s : if c() then { (output d and s()); while_f(d,c)(s) } else empty ))) and
  X = 0  and always output (X) and
   while_f( 2 ,  (%  : X<5) )( (%  : X:=X+1 and skip ) ) and
  exists Y : {
   Y = 0  and always output (Y) and
   while_f( 3 ,  (%  : Y<5) )( (%  : Y:=Y+1 and skip ) )
   }
 }
}.

/* run */ define test_14_a_5() = {
 exists X: {
  define while_f = (% d : (% c : (% s : if c() then { (output d and s()); while_f(d)(c)(s) } else empty ))) and
  X = 0  and always output (X) and
   while_f( 2 )( (%  : X<5) )( (%  : X:=X+1 and skip ) ) and
  exists Y : {
   Y = 0  and always output (Y) and
   while_f( 3 )( (%  : Y<5) )( (%  : Y:=Y+1 and skip ) )
   }
 }
}.

/* run */ define test_14_b() = {
 exists X: {
  
  exists X : {
  load "external_func" and
   X = 0  and always output (X) and
   output (while_f( (%  : X<5) )) and
   while_f( (%  : X<5) )( (%  : X:=X+1 and skip ) )
   }
 }
}.

define while_a = (% c0 : (% s0 : if c0() then { s0(); while_a(c0)(s0) } else empty )).  

/* run */ define test_14_c() = {
 exists X,Y: {
  define while_b = (% c1 : (% s1 : if c1() then { s1(); while_b(c1)(s1) } else empty )) and
   X = 0 and Y = 0 and always output (X,Y) and
   while_b( (%  : Y<3) )( (%  : Y:=Y+1 and skip ) ) and
   while_a( (%  : X<3) )( (%  : X:=X+1 and skip ) ) and
  exists X,Y,Z : {  
   define while_c = (% c2 : (% s2 : if c2() then { s2(); while_c(c2)(s2) } else empty )) and
   X = 0 and Y = 0 and Z = 0 and always output (X,Y,Z) and
   while_a( (%  : X<3) )( (%  : X:=X+1 and skip ) ) and
   while_b( (%  : Y<3) )( (%  : Y:=Y+1 and skip ) ) and
   while_c( (%  : Z<3) )( (%  : Z:=Z+1 and skip ) ) 
   }
 }
}.

