/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * lambda operators
 */

define f_curry   = (lambda op: (lambda x: (lambda y: op(x,y) ))).
define f_uncurry = (lambda op: (lambda x,y: op(x)(y))).
define f_comp    = (lambda f: (lambda g: (lambda x: f(g(x)) ))).
define f_then    = (lambda f: (lambda g: (lambda x: g(f(x)) ))).
define f_id      = (lambda x: x).
define f_const   = (lambda x: (lambda y: x)).
define f_flip    = (lambda op: (lambda x: (lambda y: op(y)(x) ))). 
