/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of lambda operators
 */

load "lambda_operators".

set debug_level = 1.
set print_level = 10.


define plus_a    = (lambda x1,y1: x1 + y1).
define plus_b    = (lambda x1: (lambda y1: x1 + y1)).
define mult_a    = (lambda x1,y1: x1 * y1).
define mult_b    = (lambda x1: (lambda y1: x1 * y1)). 

  
/* run */ define test_1() = {
 exists X: {
   X = f_curry(plus_a)(2)(3) and
   output (X,f_curry((lambda x1,y1: x1 * y1))(2)(3)) and empty
 }
}.

/* run */ define test_2() = {
 exists X: {
  X = f_uncurry(plus_b)(2,3) and
  output (X, f_uncurry((lambda x1: (lambda y1: x1 * y1)))(2,3)) and empty
 }
}.

/* run */ define test_3() = {
 exists X,Y,Z: {
  Y = (% x: 2+x) and Z = (% x: 3+x) and 
  X = f_comp(Y)(Z)(4) and output (X, Y, Z) and empty
 }
}.

/* run */ define test_4() = {
 exists X,Y,Z: {
  Y = f_comp((lambda x: (lambda y: x + y))(2)) and
  Z = Y((lambda x: (lambda y: x + y))(3)) and 
  X = Z(4) and output (X, Y, Z) and empty
 }
}.

/* run */ define test_5() = {
  exists X,Y,Z: {
    Y = f_comp(plus_b(2)) and Z = Y(plus_b(3)) and 
  X = Z(4) and output (Y, Z, X) and empty
 }
}.

/* run */ define test_6() = {
 exists X,Y,Z: {
   Y = f_comp(plus_b(2))(plus_b(3)) and 
   X = Y(4) and output (Y, X, f_comp(plus_b(2))(mult_b(3))(4)) and empty
 }
}.

/* run */ define test_7() = {
 exists X,Y,Z: {
   Y = f_comp(f_id)(f_const(3)) and 
   X = Y(4) and
   output (Y, X, f_then(plus_b(2))(mult_b(3))(4)) and empty
 }
}.

