/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987-2019, 2021, 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Simple example of projection.   
 * Ben Moszkowski. 
 */

/* Requires set(future_asgn_flag,false) */

define body(I,J) = {
    (I=0) and (I gets I+1) and (J=0) and (J gets J+I) and halt (I=4)
}.

/* run */ define simple_proj_test() = exists I,J: {
    {
	{(skip and stable I and stable J) ; skip}
        proj 
	body(I,J)
    }
    and always format("I=%3d  J=%3d\n",I,J)
}.

/* run */ define var_proj_test() = exists I,J: {
    {{
	(len(I) and stable I and stable J);
	skip
    } proj {
	body(I,J)
    }
    }
    and always format("I=%3d  J=%3d\n",I,J)
}.
