/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of defuzzification methods
 */
 
/******************************************************************/

load "fuzzy_logic".

/* run */ define test_1() = {
  exists mf_X,X,Mu_X,V : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = pi_mf($1$,$4$,$5$,$10$) and
   Mu_X = map(mf_X, X) and
   V = centroid(X, Mu_X) and
   output(V) and empty
 }
}.

/* run */ define test_2() = {
  exists mf_X,X,Mu_Y,V : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = pi_mf($1$,$4$,$5$,$10$) and
   Mu_X = map(mf_X, X) and
   V = mom(X, Mu_X, max_list(Mu_X)) and
   output(V) and empty
 }
}.

/* run */ define test_3() = {
  exists mf_X,X,Mu_Y,V : {
   X = lrange_fl($0$, $0.1$, $10$) and
   mf_X = pi_mf($1$, $4$, $5$, $10$) and
   Mu_X = map(mf_X, X) and
   V = som(X, Mu_X, max_list(Mu_X)) and
   output(V) and empty
 }
}.

/* run */ define test_4() = {
  exists mf_X,X,Mu_X,V : {
   X = lrange_fl($0$, $0.1$, $10$) and
   mf_X = pi_mf($1$, $4$, $5$, $10$) and
   Mu_X = map(mf_X, X) and
   V = lom(X, Mu_X, max_list(Mu_X)) and
   output(V) and empty
 }
}.

/* run */ define test_5() = {
  exists mf_X,X,Mu_X,V : {
   X = lrange_fl($0$, $0.1$, $10$) and
   mf_X = pi_mf($1$, $4$, $5$, $10$) and
   Mu_X = map(mf_X, X) and
   /*S0 = binsearch(X, Y, 0, |X|-1, (|X|-1)/2, trapz(X,Y) / $2$) and
   S1 = trapz(take(52,X),take(52,Y)) and
   S2 = trapz(drop(52,X),drop(52,Y)) and
   S = trapz(X,Y) / $2$ and
   */
   /*W = [ trapz( (take(i, X)), (take(i, Y)) ) : i < |X|] and*/
   V = bisector(X, Mu_X) and
   output(V) and empty
 }
}.



