/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 2023 Roger Hale, Ben Moszkowski,
 * Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * test of fuzzy operators
 */
 
load "fuzzy_logic".

/* run */ define test_1() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_min(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_2() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_product(Mu_X, Mu_Y) and
  output(Mu_Z) and empty
 }
}.

/* run */ define test_3() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_lukasiewicz(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_4() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_drastic(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_5() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_nilpotent_min(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_6() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_hamacher(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_7() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_and_einstein(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_8() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_max(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_9() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_sum(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_10() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_lukasiewicz(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_11() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_drastic(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_12() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_nilpotent_max(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_13() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_hamacher(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_14() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_or_einstein(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_15() = {
  exists mf_X,X,Mu_X,Mu_Y : {
   X = lrange_fl($0$,$0.1$,$10$) and
   mf_X = trapezoid_mf($1$,$5$,$7$,$8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = l_f_not(Mu_X) and
   output(Mu_Y) and empty
 }
}.

/* run */ define test_16() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_b_difference(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_17() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_b_sum(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_18() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_larsen(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_19() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_mamdani(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_20() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_min(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_21() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_goguen(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_22() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_lukasiewicz(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_23() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_nilpotent_min(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_24() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_standard_strict(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.

/* run */ define test_25() = {
  exists mf_X,mf_Y,X,Y,Mu_X,Mu_Y,Mu_Z : {
   X = lrange_fl($0$,$0.1$,$10$) and
   Y = lrange_fl($0$,$0.3$,$30$) and
   mf_X = trapezoid_mf($1$, $5$, $7$, $8$) and
   mf_Y = trapezoid_mf($1$, $4$, $6$, $8$) and
   Mu_X = map(mf_X, X) and
   Mu_Y = map(mf_Y, Y) and
   Mu_Z = l_imp_dkl(Mu_X, Mu_Y) and
   output(Mu_Z) and empty
 }
}.













































